# remirepo/Fedora spec file for php-zendframework-zend-http
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    78aa510c0ea64bfb2aa234f50c4f232c9531acfa
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-http
%global php_home     %{_datadir}/php
%global library      Http
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.7.0
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-ctype
BuildRequires:  php-curl
BuildRequires:  php-date
BuildRequires:  php-fileinfo
BuildRequires:  php-openssl
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-zlib
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)         >= 2.5.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-uri)            >= 2.5.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1
# From composer, "require-dev": {
#        "phpunit/phpunit": "^6.4.1 || ^5.7.15",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-config": "^3.1 || ^2.6"
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)         >= 2.5
%if 0%{?fedora} >= 26
%global phpunit %{_bindir}/phpunit6
%else
%global phpunit %{_bindir}/phpunit
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-loader": "^2.5.1",
#        "zendframework/zend-stdlib": "^3.1 || ^2.7.7",
#        "zendframework/zend-uri": "^2.5.2",
#        "zendframework/zend-validator": "^2.10.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:       php-autoloader(%{gh_owner}/zend-loader)         >= 2.5.1
Requires:       php-autoloader(%{gh_owner}/zend-loader)         <  3
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-uri)            >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-uri)            <  3
Requires:       php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.1
Requires:       php-autoloader(%{gh_owner}/zend-validator)      <  3
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.1
Requires:       php-ctype
Requires:       php-curl
Requires:       php-date
Requires:       php-fileinfo
Requires:       php-openssl
Requires:       php-pcre
Requires:       php-spl
Requires:       php-zlib

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Http is a primary foundational component of Zend Framework.
Since much of what PHP does is web-based, specifically HTTP,
it makes sense to have a performant, extensible, concise and
consistent API to do all things HTTP.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Loader/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Config/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" php70 php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit6} || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.7.0-2
- switch from zend-loader to fedora/autoloader

* Thu Nov  2 2017 Remi Collet <remi@remirepo.net> - 2.7.0-1
- Update to 2.7.0
- use phpunit6 on F26+
- raise dependency on PHP 5.6
- raise dependency on zendframework/zend-loader 2.5.1
- raise dependency on zendframework/zend-stdlib 2.7.7
- raise dependency on zendframework/zend-uri 2.5.2
- raise dependency on zendframework/zend-validator 2.10.1

* Wed Feb  1 2017 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- version 2.6.0

* Mon Aug  8 2016 Remi Collet <remi@fedoraproject.org> - 2.5.5-1
- version 2.5.5

* Fri Feb  5 2016 Remi Collet <remi@fedoraproject.org> - 2.5.4-1
- version 2.5.4

* Tue Sep 15 2015 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- version 2.5.3

* Thu Aug  6 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- version 2.5.2

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
